import { StateEffect as E, StateField as S, EditorState as T } from "@codemirror/state";
import { EditorView as h, Decoration as l, lineNumbers as H, highlightActiveLineGutter as L, keymap as y } from "@codemirror/view";
import { defaultKeymap as M } from "@codemirror/commands";
import { HighlightStyle as A, syntaxHighlighting as F, defaultHighlightStyle as G } from "@codemirror/language";
import { javascript as K } from "@codemirror/lang-javascript";
import { tags as e } from "@lezer/highlight";
import { Drawer as W, repl as j } from "@strudel.cycles/core";
const I = "#e5c07b", C = "#e06c75", O = "#56b6c2", P = "#ffffff", g = "#abb2bf", b = "#7d8799", V = "#61afef", q = "#98c379", v = "#d19a66", z = "#c678dd", J = "#21252b", D = "#2c313a", x = "#282c34", p = "#353a42", Q = "#3E4451", B = "#528bff", R = h.theme(
  {
    "&": {
      color: g,
      backgroundColor: x
    },
    ".cm-content": {
      caretColor: B
    },
    ".cm-cursor, .cm-dropCursor": { borderLeftColor: B },
    "&.cm-focused > .cm-scroller > .cm-selectionLayer .cm-selectionBackground, .cm-selectionBackground, .cm-content ::selection": { backgroundColor: Q },
    ".cm-panels": { backgroundColor: J, color: g },
    ".cm-panels.cm-panels-top": { borderBottom: "2px solid black" },
    ".cm-panels.cm-panels-bottom": { borderTop: "2px solid black" },
    ".cm-searchMatch": {
      backgroundColor: "#72a1ff59",
      outline: "1px solid #457dff"
    },
    ".cm-searchMatch.cm-searchMatch-selected": {
      backgroundColor: "#6199ff2f"
    },
    ".cm-activeLine": { backgroundColor: "#6699ff0b" },
    ".cm-selectionMatch": { backgroundColor: "#aafe661a" },
    "&.cm-focused .cm-matchingBracket, &.cm-focused .cm-nonmatchingBracket": {
      backgroundColor: "#bad0f847"
    },
    ".cm-gutters": {
      backgroundColor: x,
      color: b,
      border: "none"
    },
    ".cm-activeLineGutter": {
      backgroundColor: D
    },
    ".cm-foldPlaceholder": {
      backgroundColor: "transparent",
      border: "none",
      color: "#ddd"
    },
    ".cm-tooltip": {
      border: "none",
      backgroundColor: p
    },
    ".cm-tooltip .cm-tooltip-arrow:before": {
      borderTopColor: "transparent",
      borderBottomColor: "transparent"
    },
    ".cm-tooltip .cm-tooltip-arrow:after": {
      borderTopColor: p,
      borderBottomColor: p
    },
    ".cm-tooltip-autocomplete": {
      "& > ul > li[aria-selected]": {
        backgroundColor: D,
        color: g
      }
    }
  },
  { dark: !0 }
), U = A.define([
  { tag: e.keyword, color: z },
  { tag: [e.name, e.deleted, e.character, e.propertyName, e.macroName], color: C },
  { tag: [e.function(e.variableName), e.labelName], color: V },
  { tag: [e.color, e.constant(e.name), e.standard(e.name)], color: v },
  { tag: [e.definition(e.name), e.separator], color: g },
  { tag: [e.typeName, e.className, e.number, e.changed, e.annotation, e.modifier, e.self, e.namespace], color: I },
  { tag: [e.operator, e.operatorKeyword, e.url, e.escape, e.regexp, e.link, e.special(e.string)], color: O },
  { tag: [e.meta, e.comment], color: b },
  { tag: e.strong, fontWeight: "bold" },
  { tag: e.emphasis, fontStyle: "italic" },
  { tag: e.strikethrough, textDecoration: "line-through" },
  { tag: e.link, color: b, textDecoration: "underline" },
  { tag: e.heading, fontWeight: "bold", color: C },
  { tag: [e.atom, e.bool, e.special(e.variableName)], color: v },
  { tag: [e.processingInstruction, e.string, e.inserted], color: q },
  { tag: e.invalid, color: P }
]), X = [R, F(U)];
function Y({ initialCode: t = "", onChange: o, onEvaluate: a, onStop: n, theme: s = X, root: m }) {
  let d = T.create({
    doc: t,
    extensions: [
      s,
      K(),
      H(),
      Z,
      L(),
      F(G),
      y.of(M),
      $,
      h.updateListener.of((i) => o(i)),
      y.of([
        {
          key: "Ctrl-Enter",
          run: () => a()
        },
        {
          key: "Ctrl-.",
          run: () => n()
        }
      ])
    ]
  });
  return new h({
    state: d,
    parent: m
  });
}
const N = E.define(), Z = S.define({
  create() {
    return l.none;
  },
  update(t, o) {
    try {
      for (let a of o.effects)
        if (a.is(N)) {
          const { haps: n } = a.value, s = n.map(
            (m) => (m.context.locations || []).map(({ start: d, end: i }) => {
              let f = o.newDoc.line(d.line).from + d.column, r = o.newDoc.line(i.line).from + i.column;
              const c = o.newDoc.length;
              return f > c || r > c ? void 0 : l.mark({
                attributes: { style: "outline: 2px solid #FFCA28;" }
              }).range(f, r);
            })
          ).flat().filter(Boolean) || [];
          t = l.set(s, !0);
        }
      return t;
    } catch {
      return l.set([]);
    }
  },
  provide: (t) => h.decorations.from(t)
});
function _(t, o) {
  t.dispatch({ effects: N.of({ haps: o }) });
}
const k = E.define(), $ = S.define({
  create() {
    return l.none;
  },
  update(t, o) {
    try {
      for (let a of o.effects)
        if (a.is(k))
          if (a.value) {
            const n = l.mark({ attributes: { style: "background-color: #FFCA2880" } });
            t = l.set([n.range(0, o.newDoc.length)]);
          } else
            t = l.set([]);
      return t;
    } catch (a) {
      return console.warn("flash error", a), t;
    }
  },
  provide: (t) => h.decorations.from(t)
}), ee = (t, o = 200) => {
  t.dispatch({ effects: k.of(!0) }), setTimeout(() => {
    t.dispatch({ effects: k.of(!1) });
  }, o);
};
class le {
  constructor(o) {
    const { root: a, initialCode: n = "", onDraw: s, drawTime: m = [-2, 2], prebake: d, ...i } = o;
    this.code = n, this.drawer = new W((r, c) => {
      const u = r.filter((w) => c >= w.whole.begin && c <= w.endClipped);
      this.highlight(u), s?.(r, c, u);
    }, m);
    const f = d();
    f.then(async () => {
      if (!s)
        return;
      const { scheduler: r, evaluate: c } = await this.repl;
      f.then(async () => {
        await c(this.code, !1), this.drawer.invalidate(r), s?.(this.drawer.visibleHaps, 0, []);
      });
    }), this.repl = j({
      ...i,
      onToggle: async (r) => {
        i?.onToggle?.(r);
        const { scheduler: c } = await this.repl;
        r ? this.drawer.start(c) : this.drawer.stop();
      },
      beforeEval: async () => {
        await f;
      },
      afterEval: (r) => {
        i?.afterEval?.(r), this.drawer.invalidate();
      }
    }), this.editor = Y({
      root: a,
      initialCode: n,
      onChange: (r) => {
        this.code = r.state.doc.toString();
      },
      onEvaluate: () => this.evaluate(),
      onStop: () => this.stop()
    });
  }
  async evaluate() {
    const { evaluate: o } = await this.repl;
    this.flash(), await o(this.code);
  }
  async stop() {
    const { scheduler: o } = await this.repl;
    o.stop();
  }
  flash(o) {
    ee(this.editor, o);
  }
  highlight(o) {
    _(this.editor, o);
  }
}
export {
  le as StrudelMirror,
  ee as flash,
  Z as highlightField,
  _ as highlightHaps,
  Y as initEditor,
  k as setFlash,
  N as setHighlights
};
